%polynomial model identification method
%[hm,hh,hl,ee]=polyid1(yd,ud,N,ted1,ted2)
%where yd, ud are the output-input data with same length. 
%yd and ud are column vectors
%N is the order of polynomial minus 1
%ted1 and ted2 are dead time and final time
%hm is the impulse response
%hh and hl are the 95% confidence interval of hm.
%ee is the prediction error
%Assumption: h(tmin)=0;h(tmax)=0;h'(tmax)=0;

function [hm,hh,hl,ee]=polyid1(yd,ud,N,ted1,ted2)
%ted1
%ted2

echo off
if ted1<1
   ted1=1;
end
if ted2 >length(yd)-2
   ted2=length(yd)-2;
end


a(1)= ted1;
a(2)= ted2;

tmin=a(1);
tmax=a(2);

q=floor(tmin);
r=floor(tmax);
m=length(yd);

alpha=1;  %decide alpha and beta here
beta=1;

%%decide the jacob polynomial order
A2=[];
[dif1,dif2,dif3,root]=ying1(N,1,1,alpha,beta);

A1=[];
for i=1:1:r-q
   xi=((i+q)*1-tmin)/(tmax-tmin);
   xintp=ying2(N+2,N+2,xi,root,dif1);
   A1=[A1;xintp'];
end

A1=[[1, zeros(1,N+1)];A1];
A2=[];
%convolve with inputs
for i=1:N+2;
   tempv=[zeros(q-1,1);A1(:,i)];
   dum=conv(tempv,ud);
   oo=size(dum);
   if (oo(1)==1)
      dum=dum';
   end
   
   A2(:,i)=dum(q:m);
end



A=A2(2:length(A2),2:N+1);

B=yd(q+1:m)';

%implement the end point constraints
vec1=[];
vec2=[];
ND=N+2;
N0=1;
N1=1;
   id=1;
   vec1=ying3(ND,N,N0,N1,1,id,dif1,dif2,dif3,root);
   vec2=ying3(ND,N,N0,N1,ND,id,dif1,dif2,dif3,root);
   vec1=vec1(2:ND-1);
   vec2=vec2(2:ND-1);
   
   vec1=vec1';
   vec2=vec2';
   
   soN=-vec2(1:N-1)/vec2(N);

   A4=A(:,1:N-1)+A(:,N)*soN;
   
   
   oo=size(B);
   if oo(1)==1
      B=B';
   end
   %A4
   %   cond(A4'*A4)
   
   %calculate the coefficients
   h=(A4'*A4)^(-1)*A4'*B;

h=[h;soN*h];

ffftt1=[];
valuei1=[];
%plot(e);
%hold on;
cc=h';

%get the impulse response in time
for i=1:1:floor(tmax)+1
   x=(i-tmin-1)/(tmax-tmin);
   if x<0
      valuei=0;
   else
      xintp=ying2(N+2,N+2,x,root,dif1);
      ffftt1=[ffftt1,i-1];
      valuei1=[valuei1;[0,cc,0]*xintp];
   end
%   plot(i-1,valuei,'r') %plot the curve
end

%save ying6

hm=[zeros(ffftt1(1)-1,1);valuei1;zeros(-ffftt1(length(ffftt1))+length(yd),1)];
%plot(hm);
%ee=(hm-imp)'*(hm-imp)

y=conv(hm,ud);
oo=size(y);
if oo(1)==1;
   y=y';
end
oo=size(yd);
if oo(1)==1;
   yd=yd';
end

%prediction error
ee=(yd-y(1:length(yd)))'*(yd-y(1:length(yd)));

ha=ee/(length(yd)-N+2);      

%pause
piii=(A4'*A4)^(-1);
%vh=ha*[piii(1,1) piii(2,2) piii(3,3) piii(4,4) piii(5,5)]
vh=piii*ha;


vhi=[];
for i=1:length(A1);
   vhi(i)=(A1(i,2:N)+soN*A1(i,N+1))*vh*(A1(i,2:N)+soN*A1(i,N+1))';
end

%confidence limit
delth=1.96*vhi.^.5;


hm=hm(1:floor(tmax));
hh=hm(1:floor(tmax))+[zeros(1,floor(tmin-1)),delth]';
hl=hm(1:floor(tmax))-[zeros(1,floor(tmin-1)),delth]';

%ignore below
%plot(hm(1:floor(tmax))+[zeros(1,floor(tmin-1)),delth]','r--')
%plot(hm(1:floor(tmax))-[zeros(1,floor(tmin-1)),delth]','r--')


%figure
%vhi=[];
%A1f=[zeros(30,7);A1];
%A1p=fft(A1f);
%for i=1:length(A1p);
 %  vhiR(i)=(real(A1p(i,2:N)+soN*A1p(i,N+1)))*vh*real((A1p(i,2:N)+soN*A1p(i,N+1)))';
  % vhiI(i)=(imag(A1p(i,2:N)+soN*A1p(i,N+1)))*vh*imag((A1p(i,2:N)+soN*A1p(i,N+1)))';
%end

%delthR=1.96*(vhiR).^.5;
%delthI=1.96*(vhiI).^.5;

%hm1=fft(hm(1:tmax));
%hm1R=real(hm1);
%hm1I=imag(hm1);
%hm1a=abs(hm1(1:tmax));
%w=[-pi-2*pi/length(hm1a):2*pi/length(hm1a):pi-4*pi/length(hm1a)];
%hm1b=[hm1a(length(hm1a)/2:1:length(hm1a));hm1a(1:length(hm1a)/2-1)];
%semilogy(w,hm1b)
%hold on
%options=foptions;
%for i=1:length(hm1);
 %  x=constr('getabsh',[hm1R(i) hm1I(i)],options,[hm1R(i)-delthR(i), hm1I(i)-delthI(i)],...
  %    [hm1R(i)+delthR(i), hm1I(i)+delthI(i)]);
   %hH(i)=-getabsh(x);
    %  x=constr('getabs',[hm1R(i) hm1I(i)],options,[hm1R(i)-delthR(i), hm1I(i)-delthI(i)],...
     % [hm1R(i)+delthR(i), hm1I(i)+delthI(i)]);
%   hL(i)=getabs(x);
%end

%hHb=[hH(length(hH)/2:1:length(hH)),hH(1:length(hH)/2-1)];
%hLb=[hL(length(hL)/2:1:length(hL)),hL(1:length(hL)/2-1)];

%semilogy(w,hHb,'r--');
%semilogy(w,hLb,'r--');

%fy1=fft([y1;zeros(length(hH)-length(y1),1)]);
%hm2a=abs(fy1(1:tmax));
%hm2b=[hm2a(length(hm2a)/2:1:length(hm2a));hm2a(1:length(hm2a)/2-1)];
%semilogy(w,hm2b,'g--');


%%%save 10241c