%polynomial model identification method
%Usage: [error,g]=polyidpe1(ted,yd,ud,N)
%where yd, ud are the output-input data with same length. 
%yd and ud are column vectors
%N is the order of polynomial minus 1
%error is the prediction error
%g is the averaged prediction error

function [error,g]=polyidpe1(ted,yd,ud,N)
%ted
%echo off
a(1)= ted(1);
a(2)= ted(2);

tmin=a(1);
tmax=a(2);
if ((tmin>=1) & (tmax < length(yd)-1))

      
q=floor(tmin);
r=floor(tmax);
m=length(yd);

alpha=1;  %decide alpha and beta here
beta=1;

%decide the jacob polynomial order
A2=[];
[dif1,dif2,dif3,root]=ying1(N+2,N,1,1,alpha,beta);

A1=[];
for i=1:1:r-q
   xi=((i+q)*1-tmin)/(tmax-tmin);
   xintp=ying2(N+2,N+2,xi,root,dif1);
   A1=[A1;xintp'];
end

A1=[[1, zeros(1,N+1)];A1];

A2=[];
%convolve with input
for i=1:N+2;
   dum=conv([zeros(q-1,1);A1(:,i)],ud);
   oo=size(dum);
   if (oo(1)==1)
      dum=dum';
   end
   
   A2(:,i)=dum(q:m);
end



A=A2(2:length(A2),2:N+1);

B=yd(q+1:m)';

%put the end constraints
vec1=[];
vec2=[];
ND=N+2;
N0=1;
N1=1;
   id=1;
   vec1=ying3(ND,N,N0,N1,1,id,dif1,dif2,dif3,root);
   vec2=ying3(ND,N,N0,N1,ND,id,dif1,dif2,dif3,root);
   vec1=vec1(2:ND-1);
   vec2=vec2(2:ND-1);
   
   vec1=vec1';
   vec2=vec2';
   
   soN=-vec2(1:N-1)/vec2(N);

   A4=A(:,1:N-1)+A(:,N)*soN;
   
   
   oo=size(B);
   if oo(1)==1
      B=B';
   end
%calculate the coefficients   
h=(A4'*A4)^(-1)*A4'*B;

h=[h;soN*h];

%get the impulse response
hm=[zeros(floor(tmin)-1,1);A1*[0; h; 0]];


hm=hm(1:floor(tmax));

%calculate the prediction error
ymodel=conv(ud,hm);
ss=size(ymodel);
pp=size(yd);

if ss(1)~=1
   ymodel=ymodel';
end

if pp(1)~=1
   yd=yd';
end

pe=yd-ymodel(1:length(yd));

error=sum(pe.*pe);

else
   disp('Warning: out of range, may come out with wrong results');
      pe=1e20*(-tmin+tmax)*ones(length(yd),1);
error=1e10;
   
end
error;
g(1)=-10;
ystd=std(pe);
error=error*abs((1-tmax/length(yd)*0.2*ystd-tmin/length(yd)*0.55*ystd));